`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    09:16:24 05/16/2007 
// Design Name: 
// Module Name:    receiver 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module receiver(REC,QUIT,CLK,ST);
	input REC;
	input CLK;
	output ST;
	output [7:0]QUIT;
	//test
	//output [9:0]_OUT;
	
	reg [1:0]csample=0;
	reg [3:0]cbit=0;
	reg startb=0;
	reg [9:0]data=0;				//data register

	always @(posedge CLK)					//counters
		begin
			if(!REC)startb<=1;
			if(startb)
			begin
				if(csample==2'h0)data[9]=REC;	//sampling
				if(csample==2'h2)data[8:0]=data[9:1];	//shifting
				csample <= csample + 1;
				if(csample==2'h2)csample <= 2'h0;
				if(csample==2'h0)
					begin
					cbit <= cbit + 1;
					if(cbit==4'h0A)
						begin
						cbit <= 4'h00;
						startb<=0;
						end
					end
			end
			else 
			begin
				cbit<=4'h0;
				csample<=2'h0;
			end
		end
		
		assign ST=startb;
		//assign QUIT[4:0] = cbit;
		//assign QUIT[7:6] = csample;
		//assign QUIT[5] = 0; 
		//assign _OUT=data;
		assign QUIT=data[7:0];

endmodule
